
function uploadChunk(chunk, url, token, method) {

    var xhr = new XMLHttpRequest();
    xhr.open(method, url, false);
    xhr.setRequestHeader('Content-Type', 'application/octet-stream');
    xhr.setRequestHeader('Authorization', 'Bearer ' + token);
    xhr.onload = function(e) {
      console.log(e)
    }
    xhr.send(chunk);

}

function uploadFileChunks(file, url, token, method) {
  const BYTES_PER_CHUNK = 1024 * 1024;
  // 1MB chunk sizes.
  const SIZE = file.size;

  var start = 0;
  var end = BYTES_PER_CHUNK;

  while (start < SIZE) {

    const chunk = file.slice(start, end);
    console.log(chunk)
    uploadChunk(chunk, url, token, method);

    start = end;
    end = start + BYTES_PER_CHUNK;
  }
}

self.onmessage = function(e) {
  console.log(e);
  if (!e.data || !e.data.file || !(e.data.file instanceof File) || !e.data.url || !e.data.token) {
    return;
  }


  uploadFileChunks(e.data.file, e.data.url, e.data.token, e.data.method || 'PUT');

}
